from Resource import *

def swtichScene():
    pass

def startOptions():
    pass

def startGame():
    pass

class FloatingButton():
    def __init__(self, x, y, fx, fy, w, h, texture, name, actuallw, toStage = 0):
        self.pos = (x,y)
        self.rect = pygame.Rect(x+fx, y+fy, w, h)
        self.texture = load(texture)
        self.hoveredtxt = load(texture+"hovered")
        self.show = True
        self.font = pygame.font.Font("fonts/AmaticSC-Regular.ttf", 30)
        self.name = name
        self.w = actuallw
        self.h = h
        self.rw = w
        self.toStage = toStage

    def getHovered(self):
        if self.rect.collidepoint(mouse_pos[0], mouse_pos[1]):
            return True
        return False

    def getDisplayPosByString(self, string):
        text_width, text_height = self.font.size(string)
        return (self.pos[0] + self.w/2 - text_width / 2, self.pos[1] - text_height / 2 )

    def draw(self):
        if self.show:
            if self.getHovered():
                display.blit(self.hoveredtxt, self.pos)
                display.blit(self.font.render(self.name, 0, (30, 30, 30)), self.getDisplayPosByString(self.name))
                if not mouse_pressed[0] and mouse_changed[0]:
                    return True
            else:
                display.blit(self.texture, self.pos)
            if crazed[0]:
                if random.randint(0,2) == 0:
                    for i in range(random.randint(4,8)):
                        display.fill((0,0,0), pygame.Rect(self.pos[0]+random.randint(0,self.rw-40), self.pos[1]+random.randint(0,self.h-40), random.randint(5,40), random.randint(5,40)))
        return False

    def debugRect(self):
        display.fill((90,90,90), self.rect)

class GuiMain():
    def __init__(self,crazed=False):
        self.bg = load("bg")
        self.tushlet = load("Tushlet")
        self.nextstage = 1
        self.ended = False

    def draw(self):
        display.blit(self.bg, (0,0))
        display.blit(self.tushlet, (250,120))

    def update(self):
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()


class GuiIntelligence():
    triggered = [True for i in range(10)]
    def __init__(self, subtitle):
        self.subtitle = subtitle
        self.floatingButtons = (
            FloatingButton(115, 160, 0, 20, 200, 200, "int_organization", "Economy Management", 200, 4),
            FloatingButton(115, 400, 0, 0, 200, 200, "int_solve", "Connect Paths", 200, 2),
            FloatingButton(325, 250, 0, 0, 90, 250, "int_mind", "Room Escape", 150, 6),
            FloatingButton(420, 185, 0, 0, 300, 400, "int_math", "Solving Equations", 300, 5),
            FloatingButton(420, 90, 0, 0, 200, 75, "int_memory", "Swapping Cups", 200, 3)
        )
        self.bg = load("bgint")
        self.ended = False
        self.nextstage = 1
        self.startQ = False
        self.readytxt = load("ready")

    def draw(self):
        display.blit(self.bg, (0,0))
        flag = True
        if self.startQ:
            display.blit(self.readytxt, (200,150))
            if crazed[0]:
                if random.randint(0,5) == 0:
                    for i in range(5):
                        display.fill((0,0,0),pygame.Rect(random.randint(0,700), random.randint(0,500),random.randint(0,100),random.randint(0,100),))
            if mouse_changed[0] and not mouse_pressed[0]:
                if pygame.Rect(200, 150, 400, 300).collidepoint(mouse_pos[0], mouse_pos[1]):
                    self.ended = True
                else:
                    self.startQ = False
                flag = False
        if self.startQ == False and flag:
            for button in self.floatingButtons:
                if button.draw() == True:
                    self.startQ = True
                    if game_stat[button.toStage-2] == 1:
                        self.subtitle.addToQueue(('It is done',))
                    elif game_stat[button.toStage-2] == 3:
                        self.subtitle.addToQueue(('It is sealed',))
                    else:
                        self.nextstage = button.toStage
                        if self.nextstage == 2 and self.triggered[0]:
                            self.triggered[0] = False
                            self.subtitle.addToQueue(('In this game, you will have go &reconnect the pipes by turning them.',
                                                      'This mini game sealed my problem &solving mind.',
                                                      'It should be a piece of cake for &you, right?'))
                        if self.nextstage == 3 and self.triggered[1]:
                            self.triggered[1] = False
                            self.subtitle.addToQueue(
                                ('In this game, you will start with &some cups, it will then be shuffled.',
                                 'You have to find the balls under &them to beat it.',
                                 'This mini game took my memories &away.',
                                 'It should be a piece of cake for &you, right?'))
                        if self.nextstage == 4 and self.triggered[2]:
                            self.triggered[2] = False
                            self.subtitle.addToQueue(
                                ('In this game, you will have to &manage your economy just like &the RTS games',
                                 'Make sure that the amount of &minerals does not exceed 75 or fall below &25',
                                 'This mini game restricted my &freedom of choices and actions',
                                 'It should be a piece of cake for &you, right?'))
                        if self.nextstage == 5 and self.triggered[3]:
                            self.triggered[3] = False
                            self.subtitle.addToQueue(
                                ('In this game, you will have to &solve equations',
                                 'Select the one of the answers &from the bottom, get 10 correct will do &the job',
                                 'This mini game restricted my &ability to calculate',
                                 'It should be a piece of cake for &you, right?'))
                        if self.nextstage == 6 and self.triggered[4]:
                            self.triggered[4] = False
                            self.subtitle.addToQueue(
                                ('This game seems broken',
                                 'Stop doing useless things'))

    def update(self):
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()


class GuiStart():
    def __init__(self):
        self.bg = load("title")
        self.nextstage = 0
        self.ended = False

    def draw(self):
        display.blit(self.bg, (0,0))

    def update(self):
        if mouse_changed[0]:
            self.ended = True