from Resource import *

class Subtitle():
    def __init__(self):
        self.nexttxt = load("next")
        self.frametxt = load("subtitleframe")
        self.queue = []
        self.speaker = "Tushlet: "
        self.font = pygame.font.Font("fonts/Action_Man_Bold.ttf", 30)
        self.pos = (75, 360)
        self.txtPos = (100, 370)
        self.floatPos = [700, 490]
        self.floatSpeed = 2

        self.totalChar = 0
        self.curreChar = 0

        self.txtQueue = []

    def addToQueue(self, subs):
        for sub in subs:
            self.queue.append(sub)

    def clear(self):
        self.queue = []
        self.txtQueue = []

    def draw(self, stage, stages):
        if self.txtQueue:
            display.blit(self.frametxt, self.pos)
            if self.totalChar == self.curreChar:
                display.blit(self.nexttxt, self.floatPos)
                self.floatPos[1] += self.floatSpeed
                if self.floatPos[1] < 485 or self.floatPos[1] > 495:
                    self.floatSpeed = -self.floatSpeed
            txts = [self.speaker,'','','']
            crrNum = 0
            for i in range(self.curreChar):
                if self.txtQueue[i] == '&':
                    crrNum += 1
                else:
                    txts[crrNum] += self.txtQueue[i]
            txtSurs = []
            for txt in txts:
                txtSurs.append(self.font.render(txt, 0, (18,18,18)))
            crrHeight = self.txtPos[1]
            for txtSur in txtSurs:
                display.blit(txtSur, (self.txtPos[0], crrHeight))
                crrHeight += 40

        else:
            if not self.queue:
                if stage == 0:
                    stages[0].ended = True

    def update(self):
        if not self.txtQueue:
            if self.queue:
                self.txtQueue = list(self.queue[0])
                self.totalChar = len(self.txtQueue)
                self.curreChar = 0
        if self.txtQueue:
            self.curreChar += 1
            if self.curreChar > self.totalChar:
                self.curreChar = self.totalChar

            if pygame.Rect(self.pos[0], self.pos[1], 675, 175).collidepoint(mouse_pos[0], mouse_pos[1]):
                if not mouse_pressed[0] and mouse_changed[0]:
                    mouse_changed[0] = False
                    if self.curreChar == self.totalChar:
                        self.txtQueue = []
                        del self.queue[0]
                    else:
                        self.curreChar = self.totalChar

subtitle = Subtitle()